/* oracleProver.h
 */
#ifndef _ORACLEPROVER_H
#define _ORACLEPROVER_H

#include "osl/checkmate/proofOracle.h"
#include "osl/checkmate/fixedDepthSearcher.h"
#include "osl/state/numEffectState.h"
#include "osl/hash/hashKey.h"
#include "osl/player.h"
#include "osl/pathEncoding.h"
namespace osl
{
  namespace checkmate
  {
    /**
     * Simulationˤͤγǧ.
     * ¦̤ǵͤΤߤ
     */
    template <class Table>
    class OracleProver
    {
    public:
      typedef NumEffectState state_t;
    private:
      Table& table;
      state_t *state;
      HashKey key;
      PathEncoding path;
      Player attacker;
      FixedDepthSearcher fixed_searcher;
      int node_count;
    public:
      explicit OracleProver(Table& t) : table(t), attacker(t.getAttacker()),
					node_count(0)
      {
      }
      /** 
       * oracle ˴Ťͤ뤫ɤȽꤹ
       * @param best_move ͤ˵ͤޤǾ񤭤
       */
      template <Player Attacker>
      bool proofWin(state_t& state, const HashKey& key,
		    const PathEncoding& path,
		    ProofOracleAttack<Attacker> oracle, 
		    Move& best_move);
      /** 
       * oracle ˴ŤͤǤ뤫ɤȽꤹ
       * @param state  alt(Attacker) ФƲ꤬äƤ뤳
       */
      template <Player Attacker>
      bool proofLose(state_t& state, const HashKey& key,
		     const PathEncoding& path,
		     ProofOracleDefense<Attacker> oracle,
		     Move last_move=Move::INVALID());

      int nodeCount() const { return node_count; }

      // private:
      template <Player P>
      void attack(CheckHashRecord *record, ProofOracleAttack<P> oracle);
      template <Player P>
      void defense(CheckHashRecord *record, ProofOracleDefense<P> oracle);
      template <Player P>
      void testFixedDepthAttack(CheckHashRecord *record, Move);
      template <Player P>
      void testFixedDepthDefense(CheckHashRecord *record, CheckMove&);

      // ƥȷtemplate instantiation 
      bool proofWin(state_t& state, const PathEncoding& path,
		    const CheckHashRecord *oracle, Move& best_move);
      bool proofLose(state_t& state, const PathEncoding& path,
		     const CheckHashRecord *oracle, Move last_move=Move::INVALID());
    };

  } // namespace checkmate
} // namespace osl

#endif /* _ORACLEPROVER_H */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
