#ifndef _GENERATE_ESCAPE_MOVES_H
#define _GENERATE_ESCAPE_MOVES_H
#include "osl/move_generator/pieceOnBoard.h"
#include "osl/move_generator/capture_.h"
#include "osl/effect_action/simpleMove.h"
#include "osl/effect_action/pieceFilter.h"
#include "osl/move_action/noEffectFilter.h"
#include "osl/move_action/notKingOpenFilter.h"
#include "osl/move_action/concept.h"
#include "osl/effect/liberty8.h"
#include "osl/move.h"
// EscapeMoves<NumEffectState, StoreMoveAction> ʳȤ߹碌ǻȤȤ
// generateEscapeMoves.tcc include 뤳 (âѥ֤Τǿ侩ʤ)

namespace osl
{
  namespace container
  {    
    class MoveVector;
  }
  namespace move_generator
  {
    /**
     * ƨ
     * unique
     */
    template<Player P,class Action,bool CheapOnly=false>
    class Escape
    {
      //      BOOST_CLASS_REQUIRE(Action,osl::move_action,Concept);
      typedef move_action::NotKingOpenFilter<P,Action> safe_action_t;
    public:
      /**
       * ζ뤳Ȥˤäƨ.
       * ƨФǼʤ2003/5/12
       * @param target toru koma no pos
       */
      static void generateCaptureKing(const NumEffectState& state,Piece p,Position target,safe_action_t& action) {
	Capture<P>::escapeByCapture(state,target,p,action);
      }
      static void generateCapture(const NumEffectState& state,Piece p,Position target,Action& action) {
	Capture<P>::escapeByCapture(state,target,p,action);
      }
      template<Ptype Type>
      static void generateEscape(const NumEffectState& state,Piece p,Action& action,Int2Type<Type>);

      
      template <bool HasLongAttack, Direction DIR>
      static void generateEscapeKing(const NumEffectState& state,Position from,Action& action) {
	const Position to = from + DirectionPlayerTraits<DIR,P>::offset();
	const Piece p = state.getPieceAt(to);
	if (! p.canMoveOn<P>() || state.hasEffectBy(alt(P), to)) return;

	if (HasLongAttack) {
	  if (DIR == D) {
	    if (state.selectLong<LANCE>(from, alt(P)).any()) return;
	  }
	  if (DIR == U || DIR == D || DIR == L || DIR == R) {
	    mask_t m = state.selectLong<ROOK>(from, alt(P));
	    if (m.any()) {
	      const int number = m.takeOneBit() + PtypeFuns<ROOK>::indexNum*32;
	      const Piece attack = state.longEffectOfDirection(P, KingTraits<P>::index, inverse(DIR));
	      if (attack.number() == number)
		return;
	    }
	  }
	  if (DIR == UL || DIR == UR || DIR == DL || DIR == DR) {
	    mask_t m = state.selectLong<BISHOP>(from, alt(P));
	    if (m.any()) {
	      const int number = m.takeOneBit() + PtypeFuns<BISHOP>::indexNum*32;
	      const Piece attack = state.longEffectOfDirection(P, KingTraits<P>::index, inverse(DIR));
	      if (attack.number() == number)
		return;
	    }
	  }
	}
	action.unknownMove(from,to,p,KING,false,P);
      }
      /**
       * @param p ƨФ
       */
      template<Ptype Type>
      static void generateEscape(const NumEffectState& state,Piece p,Action& action){
	/**
	 * @param ξ̰Ǥ
	 */
	if(Type==KING){
	  assert(p.owner()==P && p.ptype()==KING);
	  Position from=p.position();
	  if (state.selectLong(from, alt(P)).any()) {
	    generateEscapeKing<true,DR>(state, from, action);
	    generateEscapeKing<true,D>(state, from, action);
	    generateEscapeKing<true,DL>(state, from, action);
	    generateEscapeKing<true,R>(state, from, action);
	    generateEscapeKing<true,L>(state, from, action);
	    generateEscapeKing<true,UR>(state, from, action);
	    generateEscapeKing<true,U>(state, from, action);
	    generateEscapeKing<true,UL>(state, from, action);
	  }
	  else {
	    generateEscapeKing<false,DR>(state, from, action);
	    generateEscapeKing<false,D>(state, from, action);
	    generateEscapeKing<false,DL>(state, from, action);
	    generateEscapeKing<false,R>(state, from, action);
	    generateEscapeKing<false,L>(state, from, action);
	    generateEscapeKing<false,UR>(state, from, action);
	    generateEscapeKing<false,U>(state, from, action);
	    generateEscapeKing<false,UL>(state, from, action);
	  }
	}
	else
	{
	  typedef move_action::NoEffectFilter<P,Action> CheckAction;
	  CheckAction checkAction(state,action,p.position());
	  PieceOnBoardType<P,Type>::generate(state,p,checkAction);
	}
      }

      template<Ptype Type>
      static bool generateDrop(const NumEffectState& state,Position to,Action& action){
	if(state.template hasPieceOnStand<Type>(P)){
	  if((Type!=PAWN || !state.isPawnMaskSet(P,to.x())) &&
	     PtypePlayerTraits<Type,P>::canDropTo(to)){
	    action.dropMove(to,Type,P);
	    return true;
	  }
	}
	return false;
      }
      static void generateDropAll(const NumEffectState& state,Position to,Action& action);
      /**
       * .
       * frompؤפ
       */
      static void generateBlocking(const NumEffectState& state,Piece p,Position from,Action& action);
      /** fromtoؤפ.  pѤʤ */
      static void generateBlocking(const NumEffectState& state,Piece p,Position to,Position from,Action& action);
      static void generateBlockingKing(const NumEffectState& state,Piece p,Position from,Action& action,safe_action_t& safe_action);
      static void blockByMoveOne(const NumEffectState& state, Position pos, Action &action);
    public:
      static void generateKingEscape(const NumEffectState& state,Action& action);

      /** 
       * @param p 㤨 king
       */
      template<Ptype Type>
      static void generateMovesBy(const NumEffectState& state,Piece p,Piece attackerPiece,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const NumEffectState& state,Piece p,Move last_move,Action& action);
      template<Ptype Type>
      static void generateMovesBy(const NumEffectState& state,Piece p,Action& action);
    
      /**
       * ƨ
       * unique
       * ˴ؤƤϰϷŪƨƤʤƤ
       * ͽ
       * @param p ƨplayer
       * @param piece ƨ
       * @param last_move - μ
       */
      static /* inline */ void generateMoves(const NumEffectState& state,Piece piece,Move last_move,Action& action);
      /**
       */
      static /* inline */ void generateMoves(const NumEffectState& state,Piece piece,const Piece attackerPiece,Action& action);
      /**
       * last_moveƨ
       */
      static /* inline */ void generateMoves(const NumEffectState& state,Piece piece,Action& action);
    };

    template <Player P>
    struct GenerateEscape
    {
      template <class Action>
      static void generate(const NumEffectState& state, Piece piece, Action& a)
      {
	Escape<P,Action>::generateMoves(state, piece, a);
      }
      template <class Action>
      static void generateCheap(const NumEffectState& state, Piece piece, Action& a)
      {
	Escape<P,Action,true>::generateMoves(state, piece, a);
      }
    };
    struct GenerateEscapeOfTurn
    {
      template <class Action>
      static void generate(const NumEffectState& state, Piece piece, Action& a)
      {
	if (state.getTurn() == BLACK)
	{
	  Escape<BLACK,Action>::generateMoves(state, piece, a);
	}
	else
	{
	  Escape<WHITE,Action>::generateMoves(state, piece, a);
	}
      }
    };

  } // namespace move_generator
  struct GenerateEscapeKing
  {
    static void generate(const NumEffectState& state, container::MoveVector& out);
  };
  using move_generator::GenerateEscape;
} // namespace osl
#endif // _GENERATE_ESCAPE_MOVES_H
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
