/* sjis2euc.cc
 */

#include "osl/misc/sjis2euc.h"
#include <cctype>
#include <vector>

void osl::misc::sjis2euc(std::string& str)
{
  if (str.empty()) return;

  typedef std::vector<std::string::value_type> v_str;
  v_str v(str.begin(), str.end());
  size_t index = 0;
  while (index < v.size())
  {
    unsigned char c1 = static_cast<unsigned char>(v[index++]);
    if (!isascii(c1))
    {
      unsigned char c2 = static_cast<unsigned char>(v[index++]);
      sjis2euc(c1, c2);
      v[index-2] = c1;
      v[index-1] = c2;
    }
  }
  str.assign(v.begin(), v.end());
}

/**
 * Reference: 
 * http://www.net.is.uec.ac.jp/~ueno/material/kanji/sjis2euc.html
 */
void osl::misc::sjis2euc(unsigned char& c1, unsigned char& c2)
{
  if( c2 < 0x9f )
  {
    if( c1 < 0xa0 )
    {
      c1 -= 0x81;
      c1 *= 2;
      c1 += 0xa1;
    }
    else
    {
      c1 -= 0xe0;
      c1 *= 2;
      c1 += 0xdf;
    }
    if( c2 > 0x7f )
      -- c2;
    c2 += 0x61;
  }
  else
  {
    if( c1 < 0xa0 )
    {
      c1 -= 0x81;
      c1 *= 2;
      c1 += 0xa2;
    }
    else
    {
      c1 -= 0xe0;
      c1 *= 2;
      c1 += 0xe0;
    }
    c2 += 2;
  }
}
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
