/* checkmate.cc
 */
#include "osl/rating/feature/checkmate.h"
#include "osl/apply_move/applyMove.h"

struct osl::rating::Threatmate::Helper
{
  bool *result;
  NumEffectState *state;
  void operator()(Position) 
  {
    if (state->inCheck(state->getTurn())
	|| state->inCheck(alt(state->getTurn()))) {
      result = false;
      return;
    }
    state->changeTurn();
    *result = ImmediateCheckmate::hasCheckmateMove(state->getTurn(), *state);
    state->changeTurn();
  }
};

bool osl::rating::Threatmate::match(const NumEffectState& cstate, Move move, const RatingEnv&) const
{
  NumEffectState& state = const_cast<NumEffectState&>(cstate);
  bool result = false;
  Helper helper = { &result, &state };
  ApplyMoveOfTurn::doUndoMove(state, move, helper);
  return result;
}

/* ------------------------------------------------------------------------- */
