/* hasTimer.cc
 */
#include "osl/search/searchTimer.h"
#include "osl/search/usiReporter.h"
#include <iostream>

osl::search::SearchTimer::~SearchTimer()
{
}

void osl::search::
SearchTimer::testAndUpdateNextTimeTest(int node_count)
{
  Mutex::scoped_lock lk(shared_timer->mutex);
  const double elapsed = this->elapsed();
  if (elapsed > shared_timer->assigned.max.toSeconds()
      || (shared_timer->stable && elapsed > shared_timer->assigned.standard.toSeconds())) {
    throw misc::NoMoreTime();
  }
  MilliSeconds now = MilliSeconds::now();
  shared_timer->nps = node_count / (0.1+(now - shared_timer->start_time).toSeconds());
  shared_timer->next_node_count = node_count + shared_timer->nps * 0.25;
  shared_timer->last_tested = now;
#ifndef MINIMAL
  if (OslConfig::usiMode()) {
    static int skip = 0;
    if (++skip % 5 == 0)
      UsiReporter::timeInfo(node_count, elapsed);
  }
#endif
}

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
