/* usiReporter.cc
 */
#include "osl/search/usiReporter.h"
#include "osl/record/usi.h"
#include <iostream>

void osl::search::
UsiReporter::newDepth(int depth)
{
  std::ostream& os = std::cout;
  os << "info depth " << depth << "\n";
}
void osl::search::
UsiReporter::showPV(int depth, size_t node_count, double elapsed, int value, Move cur, const Move *first, const Move *last)
{
  std::ostream& os = std::cout;
  os << "info depth " << depth << " seldepth " << last-first
     << " time " << static_cast<int>(elapsed*1000) << " score cp " << value
     << " nodes " << node_count << " nps " << node_count/elapsed;
  os << " pv " << record::usi::show(cur);
  if (cur == *first)
    ++first;
  while (first != last) {
    os << ' ' << record::usi::show(*first++);
  }
  os << "\n";
}
void osl::search::
UsiReporter::rootMove(Move cur)
{
  std::ostream& os = std::cout;
  os << "info currmove " << record::usi::show(cur) << "\n";
}

void osl::search::
UsiReporter::timeInfo(size_t node_count, double elapsed)
{
  std::ostream& os = std::cout;
    os << "info time " << static_cast<int>(elapsed*1000)
       << " nodes " << node_count << " nps " << node_count/elapsed << "\n";
  os << std::flush;
}

// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
