/* dotAnalyzerProof.t.cc
 */
#include "osl/search/analyzer/dotAnalyzerAll.h"
#include "osl/search/simpleHashTable.h"
#include "osl/hash/hashKey.h"
#include <cppunit/TestCase.h>
#include <cppunit/extensions/HelperMacros.h>
#include <sstream>

using namespace osl;
using namespace osl::search;
using namespace osl::search::analyzer;

class DotAnalyzerProofTest : public CppUnit::TestFixture 
{
  CPPUNIT_TEST_SUITE(DotAnalyzerProofTest);
  CPPUNIT_TEST(testCreation);
  CPPUNIT_TEST(testEmpty);
  CPPUNIT_TEST_SUITE_END();
public:
  void testCreation()
  {
    SimpleHashTable table(10,1,false);
    std::stringstream ss;
    DotAnalyzerAll analyzer(table,ss);
  }
  void testEmpty()
  {
    SimpleHashTable table(10,1,false);
    std::stringstream ss;
    {
      DotAnalyzerAll analyzer(table,ss);
      HashKey key;
      analyzer.analyze(key,100);
    }
    CPPUNIT_ASSERT_EQUAL(std::string("digraph OSL_DotWriter {\n}\n"),
			 ss.str());
  }
};

CPPUNIT_TEST_SUITE_REGISTRATION(DotAnalyzerProofTest);

/* ------------------------------------------------------------------------- */
// ;;; Local Variables:
// ;;; mode:c++
// ;;; c-basic-offset:2
// ;;; End:
